/*
 * Program MMAMWM V0.99.9 or higher
 * (C) by Benjamin Drieu (e-mail: drieu@bocal.cs.univ-paris8.fr)
 * Feb 24rd 1998
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public Licences as published
 * by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will entertaining,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILTY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Publis License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.
 * 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */


#include "main.h"


/* Cette fonction redessine la barre qui se trouve a cote de chaque
   fenetre "managee" */
void
redrawBarre (WindowListe *tmp)
{
  XWindowAttributes xwattr;
  Window win=tmp->window;

  XGetWindowAttributes (display, win, &xwattr);

  /* On dessine ici les traits clairs qui donnent une impression de 3d */
  XSetLineAttributes (display, gc_clair, 2, LineSolid, CapButt, JoinBevel);  
  XDrawLine (display, win, gc_clair, 1, 0, 1, xwattr.height);
  XDrawLine (display, win, gc_clair, 1, xwattr.height-1,
	     MARGIN_WIDTH-1, xwattr.height-1); 
  
  /* On dessine ici les traits fonces qui donnent une impression de 3d */
  XSetLineAttributes (display, gc_fonce, 2, LineSolid, CapButt, JoinBevel);  
  XSetForeground (display, gc_fonce, PeachPuffFonce.pixel);
  XDrawLine (display, win, gc_fonce, 0, 1, MARGIN_WIDTH-1, 1); 
  XFillRectangle (display, win, gc_fonce, MARGIN_WIDTH-2, 0, 
		  xwattr.width-MARGIN_WIDTH+BORDER_WIDTH, xwattr.height); 

  /* On dessine deux points pour ameliorer l'effet 3d/relief */
  XDrawPoint (display, win, gc_clair, 0, 1);
  XDrawPoint (display, win, gc_clair, MARGIN_WIDTH-2, xwattr.height-1);

  /* On dessine le titre de la fenetre */
  drawText (tmp);
}



/* Dans le cas ou la souris se deplace sur le petit carre blanc de la
   barre de la fenetre, alors on rend ce carre marron */
void
enterBarre (Window win)
{
  XFillRectangle (display, win, gc_fonce, 0, 0, 10, 10);
}



/* L'inverse: quand la souris la quitte, on la redessine blanche */
void
leaveBarre (Window win)
{
  XFillRectangle (display, win, gc_blanc, 0, 0, 10, 10); 
}



/* Cette fonction dessine le texte sur le bord de la fenetre.  Pour
   l'instant, c'est un petit peu cavalier, mais on pourrait imaginer
   verifier la taille du texte pour faire un dessin plus joli */
void
drawText (WindowListe *tmp)
{
  int i;
  char tmpChaine[2]=" ";

  /* On dessine toutes les lettres une a une dans le sens vertical (la
     barre est verticale, donc on n'a pas le choix */
  for (i=0; i<strlen(tmp->name); i++)
    {
      tmpChaine[0]=tmp->name[i];
      XDrawString (display, tmp->window, gc_barre, 5, i*12+30, 
		   tmpChaine, 1);
    }
}
