/*
 * Program MMAMWM V0.99.9 or higher
 * (C) by Benjamin Drieu (e-mail: drieu@bocal.cs.univ-paris8.fr)
 * Feb 24rd 1998
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public Licences as published
 * by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will entertaining,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILTY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Publis License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.
 * 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */


#include "struct.h"

/* utils.c */
void getAllWindows ();
void manageWindow (Window);
void drawRectangle (int, int, int, int);
char * getName (Window); 
void installCmap (Colormap);

/* liste.c */
void initListe ();
void addToListe (Window, Window, Window, char *, Colormap);
void enleverListe (Window);
WindowListe * dansLaListe (Window);
WindowListe * dansLaListeClient (Window);
WindowListe * isClic (Window);

/* actions.c */
void myRaise (Window);
void myLower (Window);
void myMove (Window);
void myResize (WindowListe *);
void myIconify (WindowListe *);

/* x.c */
void initX ();
void openDisplay ();
void initGC ();
void initXDivers ();
void initXColors ();

/* barres.c */
void redrawBarre (WindowListe *);
void enterBarre (Window);
void leaveBarre (Window);
void drawText (WindowListe *);

/* menu.c */
void createMenu ();
void makeMenu ();
void popupMenu ();
void updateMenu ();
void drawMenuLine (int, Bool);
int getMax ();
