/*
 * Program MMAMWM V0.99.9 or higher
 * (C) by Benjamin Drieu (e-mail: drieu@bocal.cs.univ-paris8.fr)
 * Feb 24rd 1998
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public Licences as published
 * by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will entertaining,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILTY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Publis License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.
 * 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */


#include "main.h"


/* On initialise la liste a zero */
void
initListe ()
{
  debut=NULL;
}



/* Rajoute dans la liste des clients la fenetre specifiee en argument,
   avec la fenetre de decoration, la fenetre d'iconification, le nom,
   et la colormap */
void
addToListe (Window fenetre, Window client, Window clic, 
	    char *name, Colormap cmap)
{
  WindowListe *tmp;
  tmp=(WindowListe *) malloc (sizeof (WindowListe));
  
  tmp->window=fenetre;
  tmp->client=client;
  tmp->clic=clic;
  tmp->name=name;
  tmp->cmap=cmap;
  tmp->iconified=False;

  if (debut == NULL)
    {
      debut=tmp;
      tmp->s=tmp;
    }
  else
    {
      tmp->s=debut->s;
      debut->s=tmp;
    }
}



/* Renvoie un des elements de la liste si la fenetre passee en
   argument est contenue dans l'element */
WindowListe *
dansLaListe (Window fenetre)
{
  WindowListe *tmp=debut;

  if (tmp == NULL)
    {
      fprintf (stderr, "dansLaListe: Oups... debut==NULL\n");
      return NULL;
    }

  do
    {
      if (tmp->window == fenetre)
	return tmp;
      tmp=tmp->s;
    }
  while (tmp != debut);

  return NULL;
} 



/* Renvoie un des elements de la liste si une des fenetres contenues
   dans la structure est celle passee en argument */
WindowListe *
dansLaListeClient (Window fenetre)
{
  WindowListe *tmp=debut;

  if (tmp == NULL)
    {
      fprintf (stderr, "dansLaListe: Oups... debut==NULL\n");
      return NULL;
    }
  do
    {
      if (tmp->client == fenetre || tmp->window == fenetre ||
	  tmp->clic == fenetre) 
	{
	  return tmp;
	}
      tmp=tmp->s;
    }
  while (tmp != debut);
  return NULL;
} 



/* Renvoie un des elements de la structure si la fenetre passee en
   argument est l'element "clic" de la structure */
WindowListe *
isClic (Window fenetre)
{
  WindowListe *tmp=debut;

  verifDebut (tmp);
  do
    {
      if (tmp->clic == fenetre) 
	{
	  return tmp;
	}
      tmp=tmp->s;
    }
  while (tmp != debut);
  return NULL;
} 



/* Retire un element de la liste (specifie par le pointeur) */
void
enleverListe (Window fenetre)
{
  WindowListe *tmp=debut;
  WindowListe *tmpTmp;

  if (tmp == NULL)
    {
      fprintf (stderr, "dansLaListe: Oups... debut==NULL\n");
    }
  do
    {
      if (tmp->s->client == fenetre || tmp->s->window == fenetre)
	{
	  tmpTmp=tmp->s;
	  tmp->s=tmp->s->s;
	  free (tmpTmp);
	  return;
	}
      tmp=tmp->s;
    }
  while (tmp != debut);
}



